Index: /trunk/include/iprt/log.h
===================================================================
--- /trunk/include/iprt/log.h	(revision 11390)
+++ /trunk/include/iprt/log.h	(revision 11391)
@@ -373,6 +373,8 @@
     /** bird logging. */
     RTLOGGRPFLAGS_BIRD         = 0x00010000,
+    /** aleksey logging. */
+    RTLOGGRPFLAGS_ALEKSEY      = 0x00020000,
     /** NoName logging. */
-    RTLOGGRPFLAGS_NONAME       = 0x00020000
+    RTLOGGRPFLAGS_NONAME       = 0x00040000
 } RTLOGGRPFLAGS;
 
@@ -554,4 +556,9 @@
 #define LogBird(a)      LogIt(LOG_INSTANCE, RTLOGGRPFLAGS_BIRD,     LOG_GROUP, a)
 
+/** @def LogAleksey
+ * aleksey logging.
+ */
+#define LogAleksey(a)   LogIt(LOG_INSTANCE, RTLOGGRPFLAGS_ALEKSEY,  LOG_GROUP, a)
+
 /** @def LogNoName
  * NoName logging.
Index: /trunk/src/VBox/Main/Performance.cpp
===================================================================
--- /trunk/src/VBox/Main/Performance.cpp	(revision 11390)
+++ /trunk/src/VBox/Main/Performance.cpp	(revision 11391)
@@ -102,5 +102,5 @@
         {
             mLastSampleTaken = nowAt;
-            LogFlowThisFunc (("Collecting data for obj(%p)...\n", (void *)mObject));
+            Log4(("{%p} " LOG_FN_FMT ": Collecting data for obj(%p)...\n", this, __PRETTY_FUNCTION__, (void *)mObject));
             collect();
         }
@@ -437,8 +437,8 @@
     ElementList::const_iterator it;
 
-    LogFlowThisFunc(("Filter::match(%p, %s)\n", static_cast<const IUnknown*> (object), name.c_str()));
+    LogAleksey(("Filter::match(%p, %s)\n", static_cast<const IUnknown*> (object), name.c_str()));
     for (it = mElements.begin(); it != mElements.end(); it++)
     {
-        LogFlowThisFunc(("...matching against(%p, %s)\n", static_cast<const IUnknown*> ((*it).first), (*it).second.c_str()));
+        LogAleksey(("...matching against(%p, %s)\n", static_cast<const IUnknown*> ((*it).first), (*it).second.c_str()));
         if ((*it).first.isNull() || (*it).first == object)
         {
@@ -451,5 +451,5 @@
         }
     }
-    LogFlowThisFunc(("...no matches!\n"));
+    LogAleksey(("...no matches!\n"));
     return false;
 }
Index: /trunk/src/VBox/Main/PerformanceImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/PerformanceImpl.cpp	(revision 11390)
+++ /trunk/src/VBox/Main/PerformanceImpl.cpp	(revision 11391)
@@ -385,55 +385,55 @@
 void PerformanceCollector::registerBaseMetric (pm::BaseMetric *baseMetric)
 {
-    LogFlowThisFuncEnter();
+    //LogFlowThisFuncEnter();
     AutoCaller autoCaller (this);
     if (!SUCCEEDED (autoCaller.rc())) return;
 
     AutoWriteLock alock (this);
-    LogFlowThisFunc (("obj=%p name=%s\n", (void *)baseMetric->getObject(), baseMetric->getName()));
+    LogAleksey(("{%p} " LOG_FN_FMT ": obj=%p name=%s\n", this, __PRETTY_FUNCTION__, (void *)baseMetric->getObject(), baseMetric->getName()));
     m.baseMetrics.push_back (baseMetric);
-    LogFlowThisFuncLeave();
+    //LogFlowThisFuncLeave();
 }
 
 void PerformanceCollector::registerMetric (pm::Metric *metric)
 {
-    LogFlowThisFuncEnter();
+    //LogFlowThisFuncEnter();
     AutoCaller autoCaller (this);
     if (!SUCCEEDED (autoCaller.rc())) return;
 
     AutoWriteLock alock (this);
-    LogFlowThisFunc (("obj=%p name=%s\n", (void *)metric->getObject(), metric->getName()));
+    LogAleksey(("{%p} " LOG_FN_FMT ": obj=%p name=%s\n", this, __PRETTY_FUNCTION__, (void *)metric->getObject(), metric->getName()));
     m.metrics.push_back (metric);
-    LogFlowThisFuncLeave();
+    //LogFlowThisFuncLeave();
 }
 
 void PerformanceCollector::unregisterBaseMetricsFor (const ComPtr <IUnknown> &aObject)
 {
-    LogFlowThisFuncEnter();
+    //LogFlowThisFuncEnter();
     AutoCaller autoCaller (this);
     if (!SUCCEEDED (autoCaller.rc())) return;
 
     AutoWriteLock alock (this);
-    LogFlowThisFunc (("before remove_if: m.baseMetrics.size()=%d, obj=%p\n", m.baseMetrics.size(), (void *)aObject));
+    LogAleksey(("{%p} " LOG_FN_FMT ": before remove_if: m.baseMetrics.size()=%d\n", this, __PRETTY_FUNCTION__, m.baseMetrics.size()));
     BaseMetricList::iterator it = std::remove_if (
         m.baseMetrics.begin(), m.baseMetrics.end(), std::bind2nd (
             std::mem_fun (&pm::BaseMetric::associatedWith), aObject));
     m.baseMetrics.erase(it, m.baseMetrics.end());
-    LogFlowThisFunc (("after remove_if: m.baseMetrics.size()=%d\n", m.baseMetrics.size()));
-    LogFlowThisFuncLeave();
+    LogAleksey(("{%p} " LOG_FN_FMT ": after remove_if: m.baseMetrics.size()=%d\n", this, __PRETTY_FUNCTION__, m.baseMetrics.size()));
+    //LogFlowThisFuncLeave();
 }
 
 void PerformanceCollector::unregisterMetricsFor (const ComPtr <IUnknown> &aObject)
 {
-    LogFlowThisFuncEnter();
+    //LogFlowThisFuncEnter();
     AutoCaller autoCaller (this);
     if (!SUCCEEDED (autoCaller.rc())) return;
 
     AutoWriteLock alock (this);
-    LogFlowThisFunc (("obj=%p\n", (void *)aObject));
+    LogAleksey(("{%p} " LOG_FN_FMT ": obj=%p\n", this, __PRETTY_FUNCTION__, (void *)aObject));
     MetricList::iterator it = std::remove_if (
         m.metrics.begin(), m.metrics.end(), std::bind2nd (
             std::mem_fun (&pm::Metric::associatedWith), aObject));
     m.metrics.erase(it, m.metrics.end());
-    LogFlowThisFuncLeave();
+    //LogFlowThisFuncLeave();
 }
 
@@ -457,5 +457,5 @@
 void PerformanceCollector::samplerCallback()
 {
-    LogFlowThisFuncEnter();
+    Log4(("{%p} " LOG_FN_FMT ": ENTER\n", this, __PRETTY_FUNCTION__));
     AutoWriteLock alock (this);
 
@@ -464,5 +464,5 @@
                    std::bind2nd (std::mem_fun (&pm::BaseMetric::collectorBeat),
                                  timestamp));
-    LogFlowThisFuncLeave();
+    Log4(("{%p} " LOG_FN_FMT ": LEAVE\n", this, __PRETTY_FUNCTION__));
 }
 
Index: /trunk/src/VBox/Runtime/common/log/log.cpp
===================================================================
--- /trunk/src/VBox/Runtime/common/log/log.cpp	(revision 11390)
+++ /trunk/src/VBox/Runtime/common/log/log.cpp	(revision 11391)
@@ -1140,4 +1140,5 @@
             { "b",          RTLOGGRPFLAGS_BIRD },
             { "bird",       RTLOGGRPFLAGS_BIRD },
+            { "aleksey",    RTLOGGRPFLAGS_ALEKSEY },
             { "n",          RTLOGGRPFLAGS_NONAME },
             { "noname",     RTLOGGRPFLAGS_NONAME }