Index: trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 11402)
+++ trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 11404)
@@ -162,5 +162,5 @@
           action).
         </note>
-        <note>
+        <note internal="yes">
           For whoever decides to touch this enum: In order to keep the
           aforementioned comparisons valid, this state must immediately
@@ -176,7 +176,7 @@
           above it represent unstable states of the running virtual
           machine. Unless explicitly stated otherwise, no machine settings can
-          be altered when it is in one of the unstable sates.
-        </note>
-        <note>
+          be altered when it is in one of the unstable states.
+        </note>
+        <note internal="yes">
           For whoever decides to touch this enum: In order to keep the
           aforementioned comparisons valid, this state must immediately
@@ -187,5 +187,5 @@
     <const name="Stuck"                 value="6">
       <desc>
-        The execution of the machine has reached the Guru Meditaion
+        The execution of the machine has reached the "Guru Meditation"
         condition. This condition indicates an internal VMM failure which may
         happen as a result of either an unhandled low-level virtual hardware
@@ -772,13 +772,15 @@
         values are:
 
-        - <link to="DeviceType::HardDisk"/>: the media is a hard disk
+        <ul>
+        <li><link to="DeviceType::HardDisk"/>: the media is a hard disk
         that, if registered, can be obtained using the
-        <link to="IVirtualBox::getHardDisk"/> call.
-        - <link to="DeviceType::DVD"/>: the media is a CD/DVD image
+        <link to="IVirtualBox::getHardDisk"/> call.</li>
+        <li><link to="DeviceType::DVD"/>: the media is a CD/DVD image
         that, if registered, can be obtained using the
-        <link to="IVirtualBox::getDVDImage"/> call.
-        - <link to="DeviceType::Floppy"/>: the media is a Floppy image
+        <link to="IVirtualBox::getDVDImage"/> call.</li>
+        <li><link to="DeviceType::Floppy"/>: the media is a Floppy image
         that, if registered, can be obtained using the
-        <link to="IVirtualBox::getFloppyImage"/> call.
+        <link to="IVirtualBox::getFloppyImage"/> call.</li>
+        </ul>
 
         Note that if this is a deregistration notification,
@@ -2067,7 +2069,7 @@
         a string in the following format:
 
-        @code
+        <pre>
         [[group.]subgroup.]name
-        @endcode
+        </pre>
 
         where @c name is the property name and @c group, @c subgroup are zero
@@ -2533,8 +2535,4 @@
         The IBIOSSettings interface represents BIOS settings of the virtual
         machine. This is used only in the <link to="IMachine::BIOSSettings" /> attribute.
-
-        <note>With the COM API, this is an interface like all the others. With the webservice,
-        this is mapped to a structure, so querying the attribute will not return an object,
-        but a complete structure.</note>
     </desc>
     <attribute name="logoFadeIn" type="boolean">
@@ -4122,8 +4120,4 @@
         Contains information about the remote display (VRDP) capabilities and status.
         This is used in the <link to="IConsole::remoteDisplayInfo" /> attribute.
-
-        <note>With the COM API, this is an interface like all the others. With the webservice,
-        this is mapped to a structure, so querying the attribute will not return an object,
-        but a complete structure.</note>
      </desc>
 
@@ -4230,5 +4224,5 @@
       opened using one of <link to="IVirtualBox::openSession"/>,
       <link to="IVirtualBox::openRemoteSession"/> or
-      <link to="IVirtualBox::openExistingSession"/> methdods.
+      <link to="IVirtualBox::openExistingSession"/> methods.
 
       Methods of the IConsole interface allow the caller to query the current
@@ -5441,7 +5435,4 @@
      >
     <desc>
-        <note>With the COM API, this is an interface like all the others. With the webservice,
-        this is mapped to a structure, so querying the attribute will not return an object,
-        but a complete structure.</note>
     </desc>
 
@@ -6050,7 +6041,4 @@
      >
     <desc>
-        <note>With the COM API, this is an interface like all the others. With the webservice,
-        this is mapped to a structure, so querying the attribute will not return an object,
-        but a complete structure.</note>
     </desc>
     <attribute name="hardDisk" type="IHardDisk" readonly="yes">
@@ -9801,8 +9789,4 @@
       have unique logical names.
 
-      <note>With the COM API, this is an interface like all the others. With the webservice,
-        this is mapped to a structure, so querying the attribute will not return an object,
-        but a complete structure.</note>
-
       <note>
         Global shared folders are not implemented in the current vesion of the
@@ -9911,5 +9895,5 @@
     <method name="onNetworkAdapterChange">
       <desc>
-        Triggered when settions of a network adapter of the
+        Triggered when settings of a network adapter of the
         associated virtual machine have changed.
       </desc>
@@ -10222,5 +10206,5 @@
      >
     <desc>
-      Webservice only: Managed object reference.
+      Managed object reference.
 
       Only within the webservice, a managed object reference (which is really
@@ -10272,5 +10256,5 @@
      >
     <desc>
-      Webservice only: Websession manager. This provides essential services
+      Websession manager. This provides essential services
       to webservice clients.
     </desc>
@@ -10381,17 +10365,17 @@
       stores performance metrics data.
 
-      Performance metrics are associated with objects like IHost and 
-      IMachine. Each object has a distinct set of performance metrics. 
+      Performance metrics are associated with objects like IHost and
+      IMachine. Each object has a distinct set of performance metrics.
       The set can be obtained with <link to="IPerformanceCollector::getMetrics"/>.
 
-      Metric data are collected at the specified intervals and are retained 
-      internally. The interval and the number of samples retained can be set 
+      Metric data are collected at the specified intervals and are retained
+      internally. The interval and the number of samples retained can be set
       with <link to="IPerformanceCollector::setMetrics" />.
-    
-      Metrics are organized hierarchically, each level separated by slash (/). 
-      General scheme for metric name is 
-      "Category/Metric[/SubMetric][:aggregation]". For example CPU/Load/User:avg 
-      metric name stands for: CPU category, Load metric, User submetric, average 
-      aggregate. An aggregate function is computed over all retained data. Valid 
+
+      Metrics are organized hierarchically, each level separated by slash (/).
+      General scheme for metric name is
+      "Category/Metric[/SubMetric][:aggregation]". For example CPU/Load/User:avg
+      metric name stands for: CPU category, Load metric, User submetric, average
+      aggregate. An aggregate function is computed over all retained data. Valid
       aggregate functions are:
 
@@ -10416,5 +10400,5 @@
       <li>RAM/Usage</li>
       </ul>
-    
+
       The general sequence for collecting and retrieving the metrics is:
       <ul>
@@ -10424,9 +10408,9 @@
         </li>
         <li>
-          Allocate and populate an array with references to objects the metrics 
+          Allocate and populate an array with references to objects the metrics
           will be collected for. Use references to IHost and IMachine objects.
         </li>
         <li>
-          Allocate and populate an array with base metric names the data will be 
+          Allocate and populate an array with base metric names the data will be
           collected for.
         </li>
@@ -10439,10 +10423,10 @@
         </li>
         <li>
-          Allocate and populate an array with references to objects the metric 
+          Allocate and populate an array with references to objects the metric
           values will be queried for. You can re-use the object array used for
           setting base metrics.
         </li>
         <li>
-          Allocate and populate an array with metric names the data will be 
+          Allocate and populate an array with metric names the data will be
           collected for. Note that metric names differ from base metric names.
         </li>
@@ -10588,11 +10572,11 @@
         <note>
           Data collection continues behind the scenes after call to @c
-          queryMetricsData. The return data can be seen as the snapshot of 
-          the current state at the time of @c queryMetricsData call. The 
+          queryMetricsData. The return data can be seen as the snapshot of
+          the current state at the time of @c queryMetricsData call. The
           internally kept metric values are not cleared by the call. This makes
           possible querying different subsets of metrics or aggregates with
           subsequent calls. If periodic querying is needed it is highly
           suggested to query the values with @c interval*count period to avoid
-          confusion. This way a completely new set of data values will be 
+          confusion. This way a completely new set of data values will be
           provided by each query.
         </note>