Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxClipboard.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxClipboard.cpp	(revision 11429)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxClipboard.cpp	(revision 11430)
@@ -873,5 +873,5 @@
                         default:
                         {
-                            Log(("Unsupported message from host!!!"));
+                            Log(("Unsupported message from host!!!\n"));
                         }
                     }
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp	(revision 11429)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxDisplay.cpp	(revision 11430)
@@ -439,5 +439,5 @@
                             if (pCtx->pfnChangeDisplaySettingsEx != 0)
                             {
-                                Log(("VBoxDisplayThread : Detected W2K or later."));
+                                Log(("VBoxDisplayThread : Detected W2K or later.\n"));
 
                                 /* W2K or later. */
Index: /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxSeamless.cpp
===================================================================
--- /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxSeamless.cpp	(revision 11429)
+++ /trunk/src/VBox/Additions/WINNT/VBoxTray/VBoxSeamless.cpp	(revision 11430)
@@ -68,5 +68,5 @@
     if (OSinfo.dwMajorVersion <= 4)         /* Windows NT 4.0 or older */
     {
-        Log(("VBoxSeamlessInit: Windows NT 4.0 or older not supported!"));
+        Log(("VBoxSeamlessInit: Windows NT 4.0 or older not supported!\n"));
         return VERR_NOT_SUPPORTED;
     }
Index: /trunk/src/VBox/HostServices/SharedOpenGL/gllindrv.cpp
===================================================================
--- /trunk/src/VBox/HostServices/SharedOpenGL/gllindrv.cpp	(revision 11429)
+++ /trunk/src/VBox/HostServices/SharedOpenGL/gllindrv.cpp	(revision 11430)
@@ -93,5 +93,5 @@
 int vboxglGlobalUnload()
 {
-    Log(("vboxglGlobalUnload"));
+    Log(("vboxglGlobalUnload\n"));
 
     if (glXDisplay)
Index: /trunk/src/VBox/Main/solaris/PerformanceSolaris.cpp
===================================================================
--- /trunk/src/VBox/Main/solaris/PerformanceSolaris.cpp	(revision 11429)
+++ /trunk/src/VBox/Main/solaris/PerformanceSolaris.cpp	(revision 11430)
@@ -103,5 +103,5 @@
             if (kstat_read(mKC, ksp, &cpu_stats) == -1)
             {
-                Log(("kstat_read() -> %d", errno));
+                Log(("kstat_read() -> %d\n", errno));
                 return VERR_INTERNAL_ERROR;
             }
@@ -150,5 +150,5 @@
         else
         {
-            Log(("read() -> %d", errno));
+            Log(("read() -> %d\n", errno));
             rc = VERR_FILE_IO_ERROR;
         }
@@ -157,5 +157,5 @@
     else
     {
-        Log(("open() -> %d", errno));
+        Log(("open() -> %d\n", errno));
         rc = VERR_ACCESS_DENIED;
     }
@@ -180,10 +180,10 @@
     if (kstat_read(mKC, mSysPages, 0) == -1)
     {
-        Log(("kstat_read(sys_pages) -> %d", errno));
+        Log(("kstat_read(sys_pages) -> %d\n", errno));
         return VERR_INTERNAL_ERROR;
     }
     if ((kn = (kstat_named_t *)kstat_data_lookup(mSysPages, "freemem")) == 0)
     {
-        Log(("kstat_data_lookup(freemem) -> %d", errno));
+        Log(("kstat_data_lookup(freemem) -> %d\n", errno));
         return VERR_INTERNAL_ERROR;
     }
@@ -191,5 +191,5 @@
     if ((kn = (kstat_named_t *)kstat_data_lookup(mSysPages, "physmem")) == 0)
     {
-        Log(("kstat_data_lookup(physmem) -> %d", errno));
+        Log(("kstat_data_lookup(physmem) -> %d\n", errno));
         return VERR_INTERNAL_ERROR;
     }
@@ -221,5 +221,5 @@
         else
         {
-            Log(("read() -> %d", errno));
+            Log(("read() -> %d\n", errno));
             rc = VERR_FILE_IO_ERROR;
         }
@@ -228,5 +228,5 @@
     else
     {
-        Log(("open() -> %d", errno));
+        Log(("open() -> %d\n", errno));
         rc = VERR_ACCESS_DENIED;
     }