Index: trunk/src/VBox/Installer/solaris/Makefile.kmk
===================================================================
--- trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 11509)
+++ trunk/src/VBox/Installer/solaris/Makefile.kmk	(revision 11510)
@@ -129,5 +129,4 @@
 	virtualbox-webservice.xml \
 	smf-vboxwebsrv.sh \
-	webservice.cfg \
 	vbox.copyright \
 	ReadMe.txt
@@ -304,5 +303,4 @@
 	$(QUIET)$(if $(VBOX_WITH_WEBSERVICES),$(INSTALL) -m 0644 $(PATH_CURRENT)/virtualbox-webservice.xml         $(SOLARIS_INST_DIR)/virtualbox-webservice.xml,)
 	$(QUIET)$(if $(VBOX_WITH_WEBSERVICES),$(INSTALL) -m 0755 $(PATH_CURRENT)/smf-vboxwebsrv.sh                 $(SOLARIS_INST_DIR)/smf-vboxwebsrv.sh,)
-	$(QUIET)$(if $(VBOX_WITH_WEBSERVICES),$(INSTALL) -m 0644 $(PATH_CURRENT)/webservice.cfg                    $(SOLARIS_INST_DIR)/etc/webservice.cfg,)
 	$(QUIET)$(INSTALL) -m 0755 $(PATH_ROOT)/src/VBox/Devices/Network/solaris/vnicinit_solaris.sh            $(SOLARIS_INST_DIR)/vnic_setup.sh
 	$(QUIET)$(INSTALL) -m 0755 $(PATH_ROOT)/src/VBox/Devices/Network/solaris/vnicterm_solaris.sh            $(SOLARIS_INST_DIR)/vnic_term.sh
Index: trunk/src/VBox/Installer/solaris/makepackage.sh
===================================================================
--- trunk/src/VBox/Installer/solaris/makepackage.sh	(revision 11509)
+++ trunk/src/VBox/Installer/solaris/makepackage.sh	(revision 11510)
@@ -94,7 +94,4 @@
 filelist_fixup prototype '$3 == "opt/VirtualBox/smf-vboxwebsrv.sh=smf-vboxwebsrv.sh"'                   '$3 = "opt/VirtualBox/smf-vboxwebsrv=smf-vboxwebsrv.sh"'
 
-# webservice SMF configuration file, mark as editable.
-filelist_fixup prototype '$3 == "opt/VirtualBox/etc/webservice.cfg=webservice.cfg"'                     '$1 = "e"'
-
 # explicitly set timestamp to shutup warning
 VBOXPKG_TIMESTAMP=vbox`date '+%Y%m%d%H%M%S'`
Index: trunk/src/VBox/Installer/solaris/postinstall.sh
===================================================================
--- trunk/src/VBox/Installer/solaris/postinstall.sh	(revision 11509)
+++ trunk/src/VBox/Installer/solaris/postinstall.sh	(revision 11510)
@@ -63,8 +63,6 @@
 fi
 /usr/sbin/removef $PKGINST /opt/VirtualBox/etc/devlink.tab 1>/dev/null
-rm -f /opt/VirtualBox/etc/devlink.tab
-#disabled as /opt/VirtualBox/etc is actually used for permanent config files.
-#/usr/sbin/removef $PKGINST /opt/VirtualBox/etc 1>/dev/null
-#rm -rf /opt/VirtualBox/etc
+/usr/sbin/removef $PKGINST /opt/VirtualBox/etc 1>/dev/null
+rm -rf /opt/VirtualBox/etc
 /usr/sbin/removef -f $PKGINST
 
Index: trunk/src/VBox/Installer/solaris/smf-vboxwebsrv.sh
===================================================================
--- trunk/src/VBox/Installer/solaris/smf-vboxwebsrv.sh	(revision 11509)
+++ trunk/src/VBox/Installer/solaris/smf-vboxwebsrv.sh	(revision 11510)
@@ -39,11 +39,13 @@
         fi
 
-        if [ ! -f /opt/VirtualBox/etc/webservice.cfg ]; then
-            echo "ERROR: /opt/VirtualBox/etc/webservice.cfg does not exist."
-            return $SMF_EXIT_ERR_CONFIG
-        fi
+        # Get svc configuration
+        VW_USER=`/usr/bin/svcprop -p config/user $SMF_FMRI 2>/dev/null`
+        [ $? != 0 ] && VW_USER=
+        VW_HOST=`/usr/bin/svcprop -p config/host $SMF_FMRI 2>/dev/null`
+        [ $? != 0 ] && VW_HOST=
+        VW_PORT=`/usr/bin/svcprop -p config/port $SMF_FMRI 2>/dev/null`
+        [ $? != 0 ] && VW_PORT=
 
-        . /opt/VirtualBox/etc/webservice.cfg
-
+        # Provide sensible defaults
         [ -z "$VW_USER" ] && VW_USER=root
         [ -z "$VW_HOST" ] && VW_HOST=localhost
Index: trunk/src/VBox/Installer/solaris/virtualbox-webservice.xml
===================================================================
--- trunk/src/VBox/Installer/solaris/virtualbox-webservice.xml	(revision 11509)
+++ trunk/src/VBox/Installer/solaris/virtualbox-webservice.xml	(revision 11510)
@@ -75,5 +75,5 @@
         type='method'
         name='stop'
-        exec='/opt/VirtualBox/smf-vboxwebsrv %m'
+        exec='/opt/VirtualBox/smf-vboxwebsrv %m %{restarter/contract}'
         timeout_seconds='15'>
         <method_context>
@@ -81,4 +81,10 @@
         </method_context>
     </exec_method>
+
+    <property_group name='config' type='application'>
+        <propval name='user' type='astring' value='root' />
+        <propval name='host' type='astring' value='localhost' />
+        <propval name='port' type='integer' value='18083' />
+    </property_group>
 
     <stability value='External' />
Index: trunk/src/VBox/Installer/solaris/webservice.cfg
===================================================================
--- trunk/src/VBox/Installer/solaris/webservice.cfg	(revision 11509)
+++ 	(revision )
@@ -1,32 +1,0 @@
-# Sun xVM VirtualBox
-# VirtualBox webservice configuration.
-#
-# Copyright (C) 2007-2008 Sun Microsystems, Inc.
-#
-# This file is part of VirtualBox Open Source Edition (OSE), as
-# available from http://www.virtualbox.org. This file is free software;
-# you can redistribute it and/or modify it under the terms of the GNU
-# General Public License (GPL) as published by the Free Software
-# Foundation, in version 2 as it comes in the "COPYING" file of the
-# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
-# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
-#
-# Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
-# Clara, CA 95054 USA or visit http://www.sun.com if you need
-# additional information or have any questions.
-#
-
-# User which runs the webservice daemon. Using a user other than the default
-# "root" is strongly encouraged to avoid unnecessary privilege.
-VW_USER=root
-
-# Listen address of the webservice. The default (localhost) is the safest
-# configuration, and if you want remote access you should consider using
-# apache in reverse proxy configuration to do access control and encryption.
-VW_HOST=localhost
-
-# Port on which the webservice listens. Default (18083) may be used if no
-# other service uses this port on this machine.
-VW_PORT=18083
-
-# end of VirtualBox webservice configuration