Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSettingsSelector.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSettingsSelector.cpp	(revision 11529)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSettingsSelector.cpp	(revision 11530)
@@ -95,5 +95,5 @@
 }
 
-QList<VBoxSettingsPage*> VBoxSettingsSelector::settingPages() const 
+QList<VBoxSettingsPage*> VBoxSettingsSelector::settingPages() const
 {
     QList<VBoxSettingsPage*> list;
@@ -104,5 +104,5 @@
 }
 
-QList<QWidget*> VBoxSettingsSelector::rootPages() const 
+QList<QWidget*> VBoxSettingsSelector::rootPages() const
 {
     QList<QWidget*> list;
@@ -201,7 +201,7 @@
 }
 
-QWidget *VBoxSettingsTreeViewSelector::addItem (const QString &aBigIcon, 
-                                                const QString &aSmallIcon, 
-                                                int aId, 
+QWidget *VBoxSettingsTreeViewSelector::addItem (const QString &aBigIcon,
+                                                const QString &aSmallIcon,
+                                                int aId,
                                                 const QString &aLink,
                                                 VBoxSettingsPage* aPage /* = NULL */,
@@ -362,5 +362,5 @@
     mTbSelector = new VBoxToolBar (aParent);
     mTbSelector->setUsesTextLabel (true);
-    mTbSelector->setUsesBigPixmaps (true);
+    mTbSelector->setIconSize (QSize (32, 32));
     /* Init the action group for house keeping */
     mActionGroup = new QActionGroup (this);
@@ -379,7 +379,7 @@
 }
 
-QWidget *VBoxSettingsToolBarSelector::addItem (const QString &aBigIcon, 
-                                               const QString &aSmallIcon, 
-                                               int aId, 
+QWidget *VBoxSettingsToolBarSelector::addItem (const QString &aBigIcon,
+                                               const QString &aSmallIcon,
+                                               int aId,
                                                const QString &aLink,
                                                VBoxSettingsPage* aPage /* = NULL */,
@@ -549,5 +549,5 @@
     QList<QAction*> list = mActionGroup->actions();
     foreach (QAction *action, list)
-       delete action; 
+       delete action;
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSnapshotsWgt.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSnapshotsWgt.cpp	(revision 11529)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxSnapshotsWgt.cpp	(revision 11530)
@@ -267,5 +267,5 @@
     VBoxToolBar *toolBar = new VBoxToolBar (this);
     toolBar->setUsesTextLabel (false);
-    toolBar->setUsesBigPixmaps (true);
+    toolBar->setIconSize (QSize (22, 22));
     toolBar->setSizePolicy (QSizePolicy::Fixed, QSizePolicy::Fixed);
 
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsHD.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsHD.cpp	(revision 11529)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsHD.cpp	(revision 11530)
@@ -448,5 +448,5 @@
     VBoxToolBar *toolBar = new VBoxToolBar (mGbAts);
     toolBar->setUsesTextLabel (false);
-    toolBar->setUsesBigPixmaps (false);
+    toolBar->setIconSize (QSize (16, 16));
     toolBar->setOrientation (Qt::Vertical);
     toolBar->addAction (mNewAction);
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsNetwork.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsNetwork.cpp	(revision 11529)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsNetwork.cpp	(revision 11530)
@@ -450,5 +450,5 @@
     VBoxToolBar *toolBar = new VBoxToolBar (this);
     toolBar->setUsesTextLabel (false);
-    toolBar->setUsesBigPixmaps (false);
+    toolBar->setIconSize (QSize (16, 16));
     toolBar->setOrientation (Qt::Vertical);
 # if defined (Q_WS_WIN)
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsSF.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsSF.cpp	(revision 11529)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsSF.cpp	(revision 11530)
@@ -217,5 +217,5 @@
     VBoxToolBar *toolBar = new VBoxToolBar (mGbSharedFolders);
     toolBar->setUsesTextLabel (false);
-    toolBar->setUsesBigPixmaps (false);
+    toolBar->setIconSize (QSize (16, 16));
     toolBar->setOrientation (Qt::Vertical);
     toolBar->addAction (mNewAction);
@@ -368,5 +368,5 @@
     /* Invoke Add-Box Dialog */
     VBoxVMSettingsSFDetails dlg (VBoxVMSettingsSFDetails::AddType,
-                                 mDialogType & ConsoleType, 
+                                 mDialogType & ConsoleType,
                                  usedList (true),
                                  this);
@@ -412,5 +412,5 @@
     /* Invoke Edit-Box Dialog */
     VBoxVMSettingsSFDetails dlg (VBoxVMSettingsSFDetails::EditType,
-                                 mDialogType & ConsoleType, 
+                                 mDialogType & ConsoleType,
                                  usedList (false),
                                  this);
Index: /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsUSB.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsUSB.cpp	(revision 11529)
+++ /trunk/src/VBox/Frontends/VirtualBox4/src/VBoxVMSettingsUSB.cpp	(revision 11530)
@@ -85,5 +85,5 @@
     VBoxToolBar *toolBar = new VBoxToolBar (mWtFilterHandler);
     toolBar->setUsesTextLabel (false);
-    toolBar->setUsesBigPixmaps (false);
+    toolBar->setIconSize (QSize (16, 16));
     toolBar->setOrientation (Qt::Vertical);
     toolBar->addAction (mNewAction);