Index: trunk/src/VBox/Runtime/generic/RTRandAdvCreateNonPseudo-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/generic/RTRandAdvCreateNonPseudo-generic.cpp	(revision 11523)
+++ 	(revision )
@@ -1,44 +1,0 @@
-/* $Id$ */
-/** @file
- * IPRT - Random Numbers, generic RTRandAdvCreateNonPseudo.
- */
-
-/*
- * Copyright (C) 2008 Sun Microsystems, Inc.
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * The contents of this file may alternatively be used under the terms
- * of the Common Development and Distribution License Version 1.0
- * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
- * VirtualBox OSE distribution, in which case the provisions of the
- * CDDL are applicable instead of those of the GPL.
- *
- * You may elect to license modified versions of this file under the
- * terms and conditions of either the GPL or the CDDL or both.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
- */
-
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
-#include <iprt/rand.h>
-#include <iprt/err.h>
-
-
-RTDECL(int) RTRandAdvCreateNonPseudo(PRTRAND phRand)
-{
-    NOREF(phRand);
-    return VERR_NOT_SUPPORTED;
-}
-
-
Index: trunk/src/VBox/Runtime/generic/RTRandAdvCreatePureNonPseudo-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/generic/RTRandAdvCreatePureNonPseudo-generic.cpp	(revision 11523)
+++ 	(revision )
@@ -1,43 +1,0 @@
-/* $Id$ */
-/** @file
- * IPRT - Random Numbers, generic RTRandAdvCreatePureNonPseudo.
- */
-
-/*
- * Copyright (C) 2008 Sun Microsystems, Inc.
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- *
- * The contents of this file may alternatively be used under the terms
- * of the Common Development and Distribution License Version 1.0
- * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
- * VirtualBox OSE distribution, in which case the provisions of the
- * CDDL are applicable instead of those of the GPL.
- *
- * You may elect to license modified versions of this file under the
- * terms and conditions of either the GPL or the CDDL or both.
- *
- * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
- * Clara, CA 95054 USA or visit http://www.sun.com if you need
- * additional information or have any questions.
- */
-
-/*******************************************************************************
-*   Header Files                                                               *
-*******************************************************************************/
-#include <iprt/rand.h>
-#include <iprt/err.h>
-
-
-RTDECL(int) RTRandAdvCreatePureNonPseudo(PRTRAND phRand)
-{
-    NOREF(phRand);
-    return VERR_NOT_SUPPORTED;
-}
-
Index: trunk/src/VBox/Runtime/generic/RTRandAdvCreateSystemFaster-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/generic/RTRandAdvCreateSystemFaster-generic.cpp	(revision 11557)
+++ trunk/src/VBox/Runtime/generic/RTRandAdvCreateSystemFaster-generic.cpp	(revision 11557)
@@ -0,0 +1,44 @@
+/* $Id$ */
+/** @file
+ * IPRT - Random Numbers, generic RTRandAdvCreateSystemFaster.
+ */
+
+/*
+ * Copyright (C) 2008 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+/*******************************************************************************
+*   Header Files                                                               *
+*******************************************************************************/
+#include <iprt/rand.h>
+#include <iprt/err.h>
+
+
+RTDECL(int) RTRandAdvCreateSystemFaster(PRTRAND phRand)
+{
+    NOREF(phRand);
+    return VERR_NOT_SUPPORTED;
+}
+
+
Index: trunk/src/VBox/Runtime/generic/RTRandAdvCreateSystemTruer-generic.cpp
===================================================================
--- trunk/src/VBox/Runtime/generic/RTRandAdvCreateSystemTruer-generic.cpp	(revision 11557)
+++ trunk/src/VBox/Runtime/generic/RTRandAdvCreateSystemTruer-generic.cpp	(revision 11557)
@@ -0,0 +1,43 @@
+/* $Id$ */
+/** @file
+ * IPRT - Random Numbers, generic RTRandAdvCreateSystemTruer.
+ */
+
+/*
+ * Copyright (C) 2008 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+/*******************************************************************************
+*   Header Files                                                               *
+*******************************************************************************/
+#include <iprt/rand.h>
+#include <iprt/err.h>
+
+
+RTDECL(int) RTRandAdvCreateSystemTruer(PRTRAND phRand)
+{
+    NOREF(phRand);
+    return VERR_NOT_SUPPORTED;
+}
+