Index: trunk/src/VBox/Devices/Makefile.kmk
===================================================================
--- trunk/src/VBox/Devices/Makefile.kmk	(revision 11734)
+++ trunk/src/VBox/Devices/Makefile.kmk	(revision 11741)
@@ -595,5 +595,5 @@
 NatAlias_CFLAGS += -include Network/nat/bsd.h
 NatAlias_DEFS += VBOX_NAT_SOURCES
-NatAlias_DEFS += __BSD_VISIBLE
+NatAlias_DEFS += __BSD_VISIBLE=1
 NatAlias_DEFS += INET
 NatAlias_DEFS += IPFIREWALL_NAT
@@ -608,9 +608,51 @@
 NatAlias_SOURCES +=	Network/nat/src/sys/netinet/ip_fw_nat.c
 NatAlias_SOURCES +=	Network/nat/src/sys/netinet/in_cksum.c
+NatAlias_SOURCES +=	Network/nat/src/sys/net/if.c
+NatAlias_SOURCES +=	Network/nat/src/sys/net/if_ef.c
+NatAlias_SOURCES +=	Network/nat/src/sys/net/if_ethersubr.c
+NatAlias_SOURCES +=	Network/nat/src/sys/net/route.c
+NatAlias_SOURCES +=	Network/nat/src/sys/net/pfil.c
+NatAlias_SOURCES +=	Network/nat/src/sys/net/netisr.c
+NatAlias_SOURCES +=	Network/nat/src/sys/net/radix.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/ip_options.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/tcp_timewait.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/tcp_timer.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/if_ether.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/in.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/in_pcb.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/in_proto.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/in_rmx.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/in_mcast.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/ip_icmp.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/ip_fastfwd.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/ip_output.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/ip_input.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/ip_mroute.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/ip_id.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/raw_ip.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/tcp_syncache.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/tcp_sack.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/tcp_subr.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/tcp_input.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/tcp_output.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/tcp_reass.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/tcp_hostcache.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/tcp_usrreq.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/udp_usrreq.c
 NatAlias_SOURCES +=	Network/nat/src/sys/kern/subr_eventhandler.c
 NatAlias_SOURCES +=	Network/nat/src/sys/kern/kern_mbuf.c
+NatAlias_SOURCES +=	Network/nat/src/sys/kern/kern_subr.c
+NatAlias_SOURCES +=	Network/nat/src/sys/kern/kern_resource.c
+NatAlias_SOURCES +=	Network/nat/src/sys/kern/kern_time.c
+NatAlias_SOURCES +=	Network/nat/src/sys/kern/kern_clock.c
+#NatAlias_SOURCES +=	Network/nat/src/sys/kern/kern_timeout.c
+NatAlias_SOURCES +=	Network/nat/src/sys/kern/subr_sbuf.c
 NatAlias_SOURCES +=	Network/nat/src/sys/kern/uipc_mbuf.c
-NatAlias_SOURCES +=	Network/nat/src/sys/vm/uma.c
-#NatAlias_SOURCES +=	Network/nat/src/sys/netinet/ip_fw2.c
+NatAlias_SOURCES +=	Network/nat/src/sys/kern/uipc_mbuf2.c
+NatAlias_SOURCES +=	Network/nat/src/sys/kern/uipc_sockbuf.c
+NatAlias_SOURCES +=	Network/nat/src/sys/kern/uipc_socket.c
+NatAlias_SOURCES +=	Network/nat/src/sys/kern/uipc_domain.c
+NatAlias_SOURCES +=	Network/nat/src/sys/vm/uma_core.c
+NatAlias_SOURCES +=	Network/nat/src/sys/netinet/ip_fw2.c
 NatAlias_SOURCES += Network/nat/src/sys/netinet/libalias/alias.c
 #NatAlias_SOURCES += Network/nat/src/sys/netinet/libalias/alias_cuseeme.c
@@ -622,5 +664,5 @@
 #NatAlias_SOURCES += Network/nat/src/sys/libalias/alias_nbt.c
 #NatAlias_SOURCES += Network/nat/src/sys/libalias/alias_pptp.c
-#NatAlias_SOURCES += Network/nat/src/sys/libalias/alias_proxy.c
+NatAlias_SOURCES += Network/nat/src/sys/netinet/libalias/alias_proxy.c
 #NatAlias_SOURCES += Network/nat/src/sys/libalias/alias_skinny.c
 #NatAlias_SOURCES += Network/nat/src/sys/libalias/alias_smedia.c
@@ -630,5 +672,9 @@
 NatAlias_SOURCES += Network/nat/src/common/lib/libc/gen/bswap64.c
 
+NatAlias_SOURCES.amd64 +=	Network/nat/src/sys/amd64/amd64/in_cksum.c
+
 NatAlias_INCS += Network/nat/src/sys
+NatAlias_INCS +=  Network/nat/src/sys/contrib/altq
+NatAlias_INCS.amd64 += Network/nat/src/sys/amd64/include
 endif
 